package md

import (
	"applet/app/db/model"
)

// MallGoodsListReq
//
//	Title 标题
//	CategoryId 类目id
//	SaleState 销售状态
//	GoodsId 销售状态
//	ActivityType 参加的活动类型
//	PageId 页数
//	PageSize 每页显示记录数
type MallGoodsListReq struct {
	Title       string `json:"title"`
	Name        string `json:"name"`
	CategoryId  string `json:"category_id"`
	SkuCode     string `json:"sku_code"`
	SaleState   string `json:"sale_state"`
	PageId      string `json:"pageId"`
	PageSize    string `json:"pageSize"`
	OrderBy     string `json:"order_by"`
	OrderBySate string `json:"order_by_sate"`
	StartPrice  string `json:"start_price"`
	EndPrice    string `json:"end_price"`
}

type GoodsRangeData struct {
	PriceRange     string `json:"price_range"`
	LinePriceRange string `json:"line_price_range"`
	ProfitRange    string `json:"profit_range"`
	WeightRange    string `json:"weight_range"`
}

type GoodsListReq struct {
	Title        string `form:"title"`
	MerchantName string `form:"merchant_name"`
	PageId       string `form:"page"`
	PageSize     string `form:"limit"`
}

type GoodListResp struct {
	GoodsId    int64        `json:"id"` // 商品id
	Price      float64      `json:"price"`
	CreateTime string       `json:"create_time"`
	UpdateTIme string       `json:"update_time"`
	Stock      int          `json:"stock"`
	SkuList    []*model.Sku `json:"sku_list"`
	SaleCount  int          `json:"sale_count"`
	Title      string       `json:"title"`
	Image      string       `json:"image"`
	State      string       `json:"state"`
}
type Sku struct {
	Name  string `json:"name"`
	Value string `json:"value"`
}
